package com.starcharge.wios.Import.impl;

import com.starcharge.wios.Import.Import;
import com.starcharge.wios.dao.entity.WallboxApply;
import com.starcharge.wios.validation.CreateEntityGroup;
import com.starcharge.wios.vo.DeliveryAddVo;
import com.starcharge.wios.vo.TauxiliarymaterialsVo;
import com.starcharge.wios.vo.WallboxApplyInstallListVO;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.util.List;
import java.util.Set;

/**
 * @projectName:wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2024/1/2215:59
 */
@Service
public class AuxiliaryMaterialImport implements Import {

    @Autowired
    private Validator validator;
    @Override
    public List<?> handle(List<Object> list) {

        for(int i=1;i<list.size();i++){
            List<String> rowdata = (List<String>)list.get(i);
            TauxiliarymaterialsVo tauxiliarymaterialsVo = new TauxiliarymaterialsVo();
            tauxiliarymaterialsVo.setTeam(rowdata.get(0));
            tauxiliarymaterialsVo.setMaterialCode(rowdata.get(1));
            tauxiliarymaterialsVo.setMaterialName(rowdata.get(2));
            tauxiliarymaterialsVo.setMeasurementUnit(rowdata.get(3));
            tauxiliarymaterialsVo.setSpecification(rowdata.get(4));
            tauxiliarymaterialsVo.setApplyQuantity(rowdata.get(5));
            tauxiliarymaterialsVo.setRecipents(rowdata.get(6));
            tauxiliarymaterialsVo.setReceiveAddress(rowdata.get(7));
            tauxiliarymaterialsVo.setAreaName(rowdata.get(8));
            tauxiliarymaterialsVo.setReceivePhone(rowdata.get(9));

            Set<ConstraintViolation<TauxiliarymaterialsVo>> sets =  validator.validate(tauxiliarymaterialsVo, CreateEntityGroup.class);
            if(!sets.isEmpty()){
                rowdata.add(sets.stream().map(ConstraintViolation::getMessage).reduce("error:",(s1,s2)->s1+";"+s2));
                continue;
            }

        }
        return list;
    }
}
