package com.starcharge.wios.Import.impl;

import com.ihidea.core.support.exception.ServiceException;
import com.starcharge.wios.Import.Import;
import com.starcharge.wios.dao.entity.Tauxiliarymaterials;
import com.starcharge.wios.dao.mappers.TauxiliarymaterialsMapper;
import com.starcharge.wios.enums2.TauxiliarymaterialStatusEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.List;

/**
 * @projectName:wios
 * @packageName:com.starcharge.wios.Import.impl
 * @Description:TODO
 * @Author:luyincheng
 * @CreateDate: 2023/11/1610:13
 */
@Service
public class AuxiliarymaterialsCheckImport implements Import {
    @Autowired
    private TauxiliarymaterialsMapper tauxiliarymaterialsMapper;
    @Override
    public List<?> handle(List<Object> list) {
        for(int i=1;i<list.size();i++){
            List<String> rowdata = (List<String>)list.get(i);
            if(rowdata.size()<=5||StringUtils.isEmpty(rowdata.get(5))){
                rowdata.add("error:批准数量不能为空");
                continue;
            }
            try{
                Float.parseFloat(rowdata.get(5));
            }catch (Exception e){
                rowdata.add("error:批准数量必须是数字");
                continue;
            }
            if(StringUtils.isEmpty(rowdata.get(1))){
                rowdata.add("error:申请单号不能为空");
                continue;
            }
            Tauxiliarymaterials exist=this.tauxiliarymaterialsMapper.selectByApplyOrder(rowdata.get(1));
            if(exist==null){
                rowdata.add("error:找不到辅材申请单");
            }else if(TauxiliarymaterialStatusEnum.getEnumByName(0,exist.getApplyStatus()).getValue()!=1){
                rowdata.add("error:辅材申请单:"+exist.getApplyOrder()+" 状态必须是已申请");
            }
        }
        return list;
    }
}
